var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { html, LitElement, property } from '@polymer/lit-element';
import { color } from './rainbow.js';
export class RainbowCode extends LitElement {
    render() {
        let colorPromise = undefined;
        if (this.textContent !== null && this.language !== undefined) {
            colorPromise = (async () => {
                const { result } = await color(this.textContent, this.language || 'generic');
                // Use a <template> to parse the result HTML
                const tmp = document.createElement('template');
                tmp.innerHTML = result;
                const node = document.importNode(tmp.content, true);
                // Hide light dom text
                this.setAttribute('highlighted', '');
                return node;
            })();
        }
        // Use comments to avoid whitespace becuase of `white-space: pre`, which
        // applies to both light and shadow dom.
        return html `<!--
    --><style>
        :host {
          display: block;
          position: relative;
          /* Create a stacking context, so we can push light dom to the top */
          z-index: 1;
        }
        /* Once the code is highlighted, hide the original source, but leave it
           laid out so that outlines will be in the right place. */
        :host([highlighted]) {
          color: transparent;
        }
        code {
          position: absolute;
          font-family: inherit;
          /* rainbow-code and code's padding need to match to align text */
          padding: var(--padding);
          margin: 0;
          top: 0;
          left: 0;
          width: 100%;
          height: 100%;
          white-space: pre;
          color: var(--color, white);
          /* So that light dom content is above and can hide code */
          z-index: -1;
        }
      </style><!--
      --><link rel="stylesheet" href="${this.theme}"><!--
      --><code>${colorPromise}</code><slot></slot>`;
    }
    connectedCallback() {
        super.connectedCallback();
        this._mutationObserver =
            new MutationObserver((records) => { this.requestUpdate(); });
        this._mutationObserver.observe(this, {
            childList: true,
            characterData: true,
        });
    }
}
__decorate([
    property()
], RainbowCode.prototype, "language", void 0);
__decorate([
    property()
], RainbowCode.prototype, "theme", void 0);
customElements.define('rainbow-code', RainbowCode);
//# sourceMappingURL=rainbow-code.js.map